unit delphiInput;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mathobjects, ExtCtrls, ToolWin, ComCtrls,
  BBInfoDialog_component;

type
  TFunctionInfo=record
    func: PFunction;
    color: tcolor;
  end;
  PFunctionInfo=^TFunctionInfo;
  TinputForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Label3: TLabel;
    formel: TEdit;
    ListView1: TListView;
    Panel1: TPanel;
    Label5: TLabel;
    Memo1: TMemo;
    BBAboutDialog1: TBBAboutDialog;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure ListView1CustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: Integer; State: TCustomDrawState;
      var DefaultDraw: Boolean);
    procedure ListView1CustomDraw(Sender: TCustomListView;
      const ARect: TRect; var DefaultDraw: Boolean);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure formelKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure formelKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure formelKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
    //procedure EnumVariables(variable: PVariable);
    procedure OnVariableCreated(system: tmathSystem; variable: PVariable);
  public
    { Public-Deklarationen }
    funcNumbers: integer;
    mathSystem: TMathSystem;
    parseOptions:TParseOptions;
    donotupdateeditbox:boolean;
  end;

var
  inputForm: TinputForm;

implementation

uses delphiRender, variables;

{$R *.DFM}

procedure TinputForm.FormCreate(Sender: TObject);
begin
  mathSystem:=TMathSystem.Create;
  mathSystem.onVariableCreatedEvent:=OnVariableCreated;
  parseOptions:=[];
  funcNumbers:=0;
//  GetKeyState(vk_return);
end;
procedure TinputForm.OnVariableCreated(system: tmathSystem; variable: PVariable);
var i:integer;
begin
  if variable^.name<>'x' then begin
    with variableForm.ListView1.Items.Add do begin
      Caption:=variable^.name;
      if variable^.name<>'pi' then begin
        SetLength(variable^.renderInfo.values,11);
        for i:=-5 to 5 do
          variable^.renderInfo.values[i+5]:=i;
        SubItems.Add('-5, ... , +5');
      end else begin
        SetLength(variable^.renderInfo.values,1);
        variable^.renderInfo.values[0]:=pi;
        SubItems.Add(FloatToStr(pi));
      end;
      SubItems.Add('clBlue');
      SubItems.Add('clRed');
      Data:=variable;
      with variable^.renderinfo do begin
        minColor:=clBlue;
        maxColor:=clRed;
      end
    end;
  end;
end;
procedure TinputForm.FormDestroy(Sender: TObject);
begin
  mathSystem.free;
end;

procedure TinputForm.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then parseOptions:=[poLongVariables]
  else parseOptions:=[];
end;

procedure TinputForm.ListView1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key=vk_delete) and (ListView1.Selected<>nil)  then begin
    dispose(ListView1.Selected.data);
    ListView1.Selected.Delete;
    renderOutputForm.Redraw;
  end;
end;

procedure TinputForm.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  if Change=ctState then
    renderOutputForm.redraw;
end;

const LVIR_BOUNDS=0;
      LVM_FIRST= $1000;
      LVM_GETSUBITEMRECT = LVM_FIRST + 56;
procedure TinputForm.ListView1CustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
var rec:trect;
begin
  if SubItem=3 then begin
    if (Item.subitems.count>0)and(Item.SubItems[0]='x') then begin
      DefaultDraw:=false;

      rec.top:=3;
      rec.left:=LVIR_BOUNDS;
      SendMessage(ListView1.Handle,LVM_GETSUBITEMRECT,item.index,lparam(@rec));
      rec.Left:=rec.Left+5;
      rec.Right:=rec.Right-5;
      ListView1.Canvas.Brush.Color:=pfunctioninfo(item.data).color;
      ListView1.Canvas.FillRect(rec);
    end;
  end else DefaultDraw:=true;
end;

procedure TinputForm.ListView1CustomDraw(Sender: TCustomListView;
  const ARect: TRect; var DefaultDraw: Boolean);
begin
  DefaultDraw:=true;
end;

procedure TinputForm.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  DefaultDraw:=true;
end;

procedure TinputForm.ListView1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var item:TListItem;
    rec: TRect;
begin
  if button=mbleft then begin
    item:=ListView1.GetItemAt(x,y);
    if item=nil then exit;
    rec.top:=3;
    rec.left:=LVIR_BOUNDS;
    SendMessage(ListView1.Handle,LVM_GETSUBITEMRECT,item.index,lparam(@rec));
    if PtInRect(rec,point(x,y)) then begin
      ColorDialog1.Color:=pfunctioninfo(item.data).color;
      if ColorDialog1.Execute then
        pfunctioninfo(item.data).color:=ColorDialog1.Color;
    end;
    ListView1.Refresh;
    renderOutputForm.redraw;
  end;
end;

procedure TinputForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if not donotupdateeditbox then
    formel.Text:=Item.Caption;
end;

procedure TinputForm.formelKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var term:PTerm;
    vars: string;
    i:integer;
    newFunc: PFunctionInfo;
    newItem: TListItem;
const col: array[0..9] of tcolor=(clBlack, clRed, clBlue, clFuchsia, clAQua, clGray,clMaroon,clNavy, clOlive, clTeal);
begin
  if (Key=vk_return) then begin
    term:=mathSystem.parse(formel.text,parseOptions);

    if (ListView1.Selected=nil) or (ssCtrl in shift) then begin
      new(newFunc);
      newFunc.color:=col[funcnumbers mod length(col)];
      newItem:=ListView1.Items.Add;
      newItem.data:=newfunc;
    end else begin
      newItem:=ListView1.Selected;
      newFunc:=newItem.Data;
    end;

    newFunc.func:=mathSystem.createFunction('x',term);
//    if color<>clred then color:=clred  else color:=cllime;
    newFunc.func.derivative:=mathSystem.derivate(newFunc.func);
//    if color<>clred then color:=clred    else color:=cllime;
    with newItem do begin
      Caption:=mathSystem.printTerm(term);
      if high(newfunc.func.variables) = -1 then vars:=''
      else begin
        vars:=newfunc.func.variables[0].name;
        for i:=1 to high(newfunc.func^.variables) do
          vars:=vars+', '+newfunc.func^.variables[i].name;
      end;
      SubItems.Clear;
      SubItems.add(vars);
      SubItems.add(mathSystem.printTerm(newfunc.func.derivative.term));
      Checked:=true;
    end;
//    ComboBox1.text:=printTerm(parsedTerm.last);
//    Label3.Caption:=printTerm(diffedTerm);
    renderOutputForm.Refresh;
    if vars='x' then
      inc(funcNumbers);
    Key:=0;
    donotupdateeditbox:=true;
    ListView1.Selected:=newItem;
    donotupdateeditbox:=false;
  end;
end;

procedure TinputForm.formelKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var term:PTerm;
    vars: string;
    i:integer;
    newFunc: PFunctionInfo;
    newItem: TListItem;
const col: array[0..9] of tcolor=(clBlack, clRed, clBlue, clFuchsia, clAQua, clGray,clMaroon,clNavy, clOlive, clTeal);
begin
  if (Key=vk_return) then begin
    term:=mathSystem.parse(formel.text,parseOptions);

    if (ListView1.Selected=nil) or (ssCtrl in shift) then begin
      new(newFunc);
      newFunc.color:=col[funcnumbers mod length(col)];
      newItem:=ListView1.Items.Add;
      newItem.data:=newfunc;
    end else begin
      newItem:=ListView1.Selected;
      newFunc:=newItem.Data;
    end;

    newFunc.func:=mathSystem.createFunction('x',term);
//    if color<>clred then color:=clred  else color:=cllime;
//ShowMessage('will calc deri');
    newFunc.func.derivative:=mathSystem.derivate(newFunc.func);
//    if color<>clred then color:=clred    else color:=cllime;
    with newItem do begin
      Caption:=mathSystem.printTerm(term);
      if high(newfunc.func.variables) = -1 then vars:=''
      else begin
        vars:=newfunc.func.variables[0].name;
        for i:=1 to high(newfunc.func^.variables) do
          vars:=vars+', '+newfunc.func^.variables[i].name;
      end;
      SubItems.Clear;
      SubItems.add(vars);
      SubItems.add(mathSystem.printTerm(newfunc.func.derivative.term));
      Checked:=true;
    end;
//    ComboBox1.text:=printTerm(parsedTerm.last);
//    Label3.Caption:=printTerm(diffedTerm);
    renderOutputForm.Refresh;
    if vars='x' then
      inc(funcNumbers);
    Key:=0;
    donotupdateeditbox:=true;
    ListView1.Selected:=newItem;
    donotupdateeditbox:=false;
  end;

end;

procedure TinputForm.formelKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then key:=#0;
end;

end.
