unit delphiRender;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,virtualRenderer, Menus,mathobjects, StdCtrls,printer;

type
  TrenderOutputForm = class(TForm)
    PopupMenu1: TPopupMenu;
    Gitter1: TMenuItem;
    Reset1: TMenuItem;
    N1: TMenuItem;
    Ableitungzeigen1: TMenuItem;
    Edit1: TEdit;
    N2: TMenuItem;
    drucken1: TMenuItem;
    Druckvorschau1: TMenuItem;
    Doublebuffer1: TMenuItem;
    N3: TMenuItem;
    simplezoom1: TMenuItem;
    AlleEinstellungen1: TMenuItem;
    Extremazeigen1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Ableitungzeigen1Click(Sender: TObject);
    procedure Druckvorschau1Click(Sender: TObject);
    procedure Doublebuffer1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure simplezoom1Click(Sender: TObject);
    procedure drucken1Click(Sender: TObject);
    procedure AlleEinstellungen1Click(Sender: TObject);
    procedure Extremazeigen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    clickX,clickY,zoomCount:longint;
    oldNull: tpoint;

    currentOutputCanvas: TCanvas;
    buffer: TBitmap;
    procedure SetColor(color:TColor);

    procedure setOutputCanvas(const can: tcanvas);


    procedure PrintDraw(canvas: TCanvas; printInfo: TPrintInfo;zoom:extended; pageNumber: longint);
    procedure Render(canvas: TCanvas; factorx,factory:extended);
    procedure RenderFilled(canvas: TCanvas; factorx,factory:extended; fillColor: TColor);
  public
    { Public-Deklarationen }

    centerNull:boolean;
    virtualRenderer: TVirtualRenderer;
    procedure redraw;
  end;
var
  renderOutputForm: TrenderOutputForm;

implementation

uses delphiInput, variables, options;

{$R *.DFM}

procedure TrenderOutputForm.SetColor(color:TColor);
begin
  currentOutputCanvas.pen.Color:=color;
end;

procedure TrenderOutputForm.setOutputCanvas(const can: tcanvas);
begin
  if can <> currentOutputCanvas then begin
    currentOutputCanvas:=Can;
    can.brush.Style:=bsClear;
    virtualRenderer.outputFunctions.moveTo:=currentOutputCanvas.MoveTo;
    virtualRenderer.outputFunctions.lineTo:=currentOutputCanvas.LineTo;
    virtualRenderer.outputFunctions.textout:=currentOutputCanvas.textout;
    virtualRenderer.outputFunctions.textWidth:=currentOutputCanvas.TextWidth;
    virtualRenderer.outputFunctions.textHeight:=currentOutputCanvas.TextHeight;
    virtualRenderer.outputFunctions.setColor:=SetColor;
  end;
end;
procedure TrenderOutputForm.PrintDraw(canvas: TCanvas; printInfo: TPrintInfo;zoom:extended; pageNumber: longint);
var cuOp:TOutputOptions;
    realzoom,tempE: Extended;
    size:tsize;
begin
  cuOp:=virtualRenderer.outputOptions;


  size.cx:=virtualRenderer.outputOptions.size.Right-virtualRenderer.outputOptions.size.Left;
  size.cy:=virtualRenderer.outputOptions.size.Bottom-virtualRenderer.outputOptions.size.Top;
  realzoom:=(printInfo.usablePageHorzPixel-10*printInfo.pixelsPerXmm)*zoom/size.cx;
  tempE:=(printInfo.usablePageVertPixel-15*printInfo.pixelsPerYmm)*zoom/size.cy;
  if tempE<realzoom then realzoom:=tempE;

  virtualRenderer.outputOptions.size.Right:=round(size.cx*realzoom);
  virtualRenderer.outputOptions.size.Bottom:=round(size.cy*realzoom);
  virtualRenderer.outputOptions.size.Left:=round((printInfo.usablePageHorzPixel*zoom-virtualRenderer.outputOptions.size.Right) / 2);
  virtualRenderer.outputOptions.size.Top:=round((printInfo.usablePageVertPixel*zoom-virtualRenderer.outputOptions.size.Bottom) / 2);
  inc(virtualRenderer.outputOptions.size.Right,virtualRenderer.outputOptions.size.Left);
  inc(virtualRenderer.outputOptions.size.Bottom,virtualRenderer.outputOptions.size.Top);

  virtualRenderer.outputOptions.intervalSizeX:=round(cuop.intervalSizeX*realzoom);
  virtualRenderer.outputOptions.intervalSizeY:=round(cuop.intervalSizeY*realzoom);
  virtualRenderer.outputOptions.factorX:=cuop.factorX/cuop.intervalSizeX*virtualRenderer.outputOptions.intervalSizeX;
  virtualRenderer.outputOptions.factorY:=cuop.factorY/cuop.intervalSizeY*virtualRenderer.outputOptions.intervalSizeY;
{  virtualRenderer.outputOptions.factorX:=round(virtualRenderer.outputOptions.factorX*realzoom);
  virtualRenderer.outputOptions.factorY:=round(virtualRenderer.outputOptions.factorY*realzoom);}

  virtualRenderer.outputOptions.null.x:=trunc((virtualRenderer.outputOptions.null.x-cuOp.size.Left)*realzoom+virtualRenderer.outputOptions.size.Left);
  virtualRenderer.outputOptions.null.y:=trunc((virtualRenderer.outputOptions.null.y-cuOp.size.Top)*realzoom+virtualRenderer.outputOptions.size.Top);

  virtualRenderer.outputOptions.coordStrikeLength:=round(4*printInfo.pixelsPerYmm*zoom);

  virtualRenderer.outputOptions.showBorder:=true;

  //  virtualRenderer.outputOptions.factorX:=

   //GetViewportOrgEx(canvas.Handle,viewport);
  canvas.Font.Name:='Arial';
  canvas.Font.Height:=trunc(7*printInfo.pixelsPerYmm*zoom);
  canvas.TextOut(round(printInfo.usablePageHorzPixel*zoom-canvas.TextWidth('BBMultiPlot by Benito van der Zander')-8*printInfo.pixelsPerXmm*zoom),0{round(5*printInfo.pixelsPerYmm*zoom)},'BBMultiPlot by Benito van der Zander');
   //GetViewportOrgEx(canvas.Handle,viewport);

  canvas.Font.Height:=trunc(5*printInfo.pixelsPerYmm*zoom);

  // GetViewportOrgEx(canvas.Handle,viewport);
  Render(canvas,realzoom,realzoom);//*pixelPerMMx,realzoom*pixelPerMMy);
  virtualRenderer.outputOptions:=cuOp;
end;
procedure TrenderOutputForm.Render(canvas: TCanvas; factorx,factory:extended);
var i:integer;
    showDerivative: boolean;
    viewport:tpoint;
 procedure showFunction(func:TFunctionInfo; const diff:boolean = false);
 begin
   if (viewport.x<>0)or(viewport.y<>0) then
     SetViewportOrgEx(canvas.Handle,viewport.x,viewport.y,nil);
   if length(func.func.variables)=0 then
     canvas.Pen.Color:=func.color;
   if diff then
     virtualRenderer.render(pterm(func.func.derivative),func.color)
    else
     virtualRenderer.render(pterm(func.func),func.color);

 end;
begin
  GetViewportOrgEx(canvas.Handle,viewport);
  setOutputCanvas(Canvas);
  virtualRenderer.renderCoordinates;

  showDerivative:=Ableitungzeigen1.Checked;
  virtualRenderer.renderCoordinates;
  for i:=0 to inputForm.ListView1.Items.Count-1 do begin
    if inputForm.ListView1.Items[i].Checked then begin
      showFunction(pfunctioninfo(inputForm.ListView1.Items[i].data)^);
      if showDerivative then
      showFunction(pfunctioninfo(inputForm.ListView1.Items[i].data)^,true);
    end;
  end;
end;
procedure TrenderOutputForm.RenderFilled(canvas: TCanvas; factorx,factory:extended; fillColor: TColor);
begin
  Canvas.brush.color:=fillColor;
  Canvas.FillRect(rect(0,0,clientwidth,clientheight));
  render(canvas,factorx,factory);
end;
procedure TrenderOutputForm.redraw;
begin
  if Doublebuffer1.Checked then begin
   if buffer=nil then exit;
   RenderFilled(buffer.Canvas,virtualRenderer.outputOptions.factorX,
                           virtualRenderer.outputOptions.factorY,color);
   Canvas.Draw(0,0,buffer);
  end else begin
   RenderFilled(Canvas,virtualRenderer.outputOptions.factorX,
                 virtualRenderer.outputOptions.factorY,color);
  end;
end;
procedure TrenderOutputForm.FormPaint(Sender: TObject);
begin
  redraw;
end;
procedure TrenderOutputForm.FormResize(Sender: TObject);
begin
  if centerNull then begin
    virtualRenderer.outputOptions.null.x:=ClientWidth div 2;
    virtualRenderer.outputOptions.null.y:=ClientHeight div 2;
  end;
  virtualRenderer.outputOptions.size.Right:=ClientWidth;
  virtualRenderer.outputOptions.size.Bottom:=clientHeight;
  if Doublebuffer1.Checked then begin
    buffer.Width:=ClientWidth;
    buffer.Height:=ClientHeight;
  end;
end;

procedure TrenderOutputForm.FormCreate(Sender: TObject);
begin
  centerNull:=true;
  virtualRenderer:=TVirtualRenderer.create;
  virtualRenderer.mathSystem:=inputForm.mathSystem;
  setOutputCanvas(Canvas);
  virtualRenderer.outputOptions.size:=clientRect;
  virtualRenderer.outputOptions.size.Top:=0;
  virtualRenderer.outputOptions.showBorder:=false;
  printer.printPreviewFrm.renderFunction:=PrintDraw;
  canvas.Font.Name:='Arial';
  canvas.Font.Size:=12;
  buffer:=TBitmap.Create;
  buffer.canvas.brush.Color:=color;
  zoomCount:=0;
end;

procedure TrenderOutputForm.FormDestroy(Sender: TObject);
begin
  virtualRenderer.free;
  buffer.free;
  buffer:=nil;
end;

procedure TrenderOutputForm.Reset1Click(Sender: TObject);
begin
  centerNull:=true;
  FormResize(sender);
  virtualRenderer.outputOptions.factorX:=50;
  virtualRenderer.outputOptions.factorY:=-50;
  Refresh;
end;

procedure TrenderOutputForm.Ableitungzeigen1Click(Sender: TObject);
begin
  Ableitungzeigen1.Checked:=not Ableitungzeigen1.Checked;
  Refresh;
end;


procedure TrenderOutputForm.Druckvorschau1Click(Sender: TObject);
begin
  printPreviewFrm.execute;
end;

procedure TrenderOutputForm.Doublebuffer1Click(Sender: TObject);
begin
  Doublebuffer1.Checked :=not Doublebuffer1.Checked ;
  if Doublebuffer1.Checked then begin
    buffer.Width:=Clientwidth;
    buffer.Height:=ClientHeight;
  end;
end;

procedure TrenderOutputForm.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if button=mbLeft then begin
    clickX:=x;
    clickY:=y;
    oldNull:=virtualRenderer.outputOptions.null;
  end;
end;

procedure TrenderOutputForm.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var pos:TPoint64F;
begin
  if ssLeft in shift then begin
    if sqr(abs(x-clickX))+sqr(abs(y-clickY))>25 then begin
      virtualRenderer.outputOptions.null.x:=oldNull.x+x-clickx;
      virtualRenderer.outputOptions.null.y:=oldNull.y+y-clicky;
      centerNull:=false;
      redraw;
    end else begin

    end;
  end;

  pos:=virtualRenderer.pixelPosToCoordPos(x,y);
  Caption:='Renderoutput ('+inttostr(x)+'/'+inttostr(y)+') ('+FloatToStr(pos.x)+'/'+FloatToStr(pos.y)+')';
end;

procedure TrenderOutputForm.FormMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
  var mulFac: double;
begin
  if WheelDelta<0 then begin
    inc(zoomCount);
    if zoomCount mod 4 = 0 then mulFac:=8/10
    else mulFac:=0.5;
  end else begin
    if zoomCount mod 4 = 0 then mulFac:=10/8
    else mulFac:=2;
    dec(zoomCount);
  end;
  if ((simplezoom1.Checked) or (ssShift in shift) or (ssLeft in shift)) and not (ssCtrl in shift) then begin
    virtualRenderer.outputOptions.factorX:=virtualRenderer.outputOptions.factorX*mulFac;
    virtualRenderer.outputOptions.factorY:=virtualRenderer.outputOptions.factorY*mulFac;
  end else begin
    if WheelDelta<0 then begin
      virtualRenderer.zoomTo(virtualRenderer.pixelPosToCoordPos(ClientWidth div 2,ClientHeight div 2),mulFac)
    end else begin
      mousepos:=ScreenToClient(mousepos);
      MousePos.x:=(MousePos.x+ClientWidth div 2) div 2;
      MousePos.y:=(mousePos.y+ClientHeight div 2) div 2;
      virtualRenderer.zoomTo(virtualRenderer.pixelPosToCoordPos( mousepos),mulFac)
    end;
  end;
  Handled:=true;
  Refresh;
end;

procedure TrenderOutputForm.simplezoom1Click(Sender: TObject);
begin
  (sender as tmenuitem).Checked:=not (sender as tmenuitem).Checked;
end;

procedure TrenderOutputForm.drucken1Click(Sender: TObject);
begin
  printPreviewFrm.print;
end;

procedure TrenderOutputForm.AlleEinstellungen1Click(Sender: TObject);
begin
  optionsFrm.ShowModal;
  zoomCount:=0;
  Refresh;
end;

procedure TrenderOutputForm.Extremazeigen1Click(Sender: TObject);
begin
  tmenuitem(sender).Checked:=not tmenuitem(sender).Checked;
  if Sender=gitter1 then
    virtualRenderer.outputOptions.showGrid:=gitter1.checked
   else if Sender=Extremazeigen1 then
    virtualRenderer.outputOptions.showExtrema:=Extremazeigen1.checked;
  Refresh;
end;

end.





