unit variables;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls,mathobjects, ExtCtrls;

type
  TvariableForm = class(TForm)
    ListView1: TListView;
    Label2: TLabel;
    valueEdt: TEdit;
    replace: TButton;
    reset: TButton;
    Label5: TLabel;
    useColor: TCheckBox;
    colorShapeFrom: TShape;
    ColorDialog1: TColorDialog;
    colorShapeTo: TShape;
    procedure FormCreate(Sender: TObject);
    procedure replaceClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormResize(Sender: TObject);
    procedure colorShapeFromMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListView1CustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: Integer; State: TCustomDrawState;
      var DefaultDraw: Boolean);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView1CustomDraw(Sender: TCustomListView;
      const ARect: TRect; var DefaultDraw: Boolean);
    procedure resetClick(Sender: TObject);
    procedure ListView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  variableForm: TvariableForm;

implementation

uses delphiInput, delphiRender;

{$R *.DFM}

procedure TvariableForm.FormCreate(Sender: TObject);
begin
  ListView1.Columns[0].Alignment:=taCenter;
end;

procedure TvariableForm.replaceClick(Sender: TObject);
var t:double;
    l,i,j,newCount:integer;
    new,num:string;
    nnum,onum: double;
    extend,lastNumber,lastPoint: Boolean;
begin
  nnum:=0;
  with ListView1.Selected do begin
    try
      new:=valueEdt.Text;
      with PVariable(data)^.renderInfo do begin
        SetLength(values,0);
        l:=0;
        extend:=FAlse;
        lastNumber:=true;
        lastPoint:=false;
        for i:=1 to length(new)+1 do begin
          if (i=length(new)+1)or(new[i]=',')or
             ((new[i] in ['-','0'..'9']) and lastPoint) or
             ((new[i] = '.') and lastNumber) then begin
            if i<length(new) then
              if (new[i] = '.') and (new[i+1] in ['0'..'9']) then continue;
            num:=copy(new,l+1,i-l);
            if pos('..',num)>0 then extend:=true
            else begin
              onum:=nnum;
              nnum:=parseNumber(num);
              if extend then begin
                newCount:=abs(round(onum-nnum));
                SetLength(values,length(values)+newCount);
                if nnum> onum then begin
                  for j:=1 to newCount do
                    values[high(values)-newCount+j]:=onum+j;
                end else
                  for j:=1 to newCount do
                    values[high(values)-newCount+j]:=onum-j;
                extend:=false;
              end else begin
                setlength(values,length(values)+1);
                values[high(values)]:=nnum;
              end;
            end;
            l:=i;
            lastNumber:=false;
            lastPoint:=false;
            if (i<=length(new)) then
              if new[i] in ['.','-','0'..'9'] then dec(l);
          end;
          if (i<=length(new)) and not (new[i]in[' ',',']) then begin
            lastNumber:=new[i] in ['-','0'..'9'];
            lastPoint:=new[i]='.';
          end;
        end;
        minColor:=colorShapeFrom.Brush.Color;
        maxColor:=colorShapeTo.Brush.Color;
      end;
    except
      reset.click;
    end;
    subitems.clear;
    SubItems.add(valueEdt.Text);
    if useColor.Checked then begin
      SubItems.add(ColorToString(colorShapeFrom.brush.Color));
      SubItems.add(ColorToString(colorShapeTo.brush.Color));
    end else begin
      SubItems.Add('');
      SubItems.Add('');
    end;

  end;
  renderOutputForm.Refresh;
end;

procedure TvariableForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if selected then begin
    replace.Enabled:=item.Caption<>'x';
    reset.Enabled:=replace.Enabled;
    valueEdt.text:=item.SubItems[0];
    useColor.Checked:=item.SubItems[1]<>'';
    if useColor.Checked then begin
      colorShapeFrom.Brush.Color:=StringToColor(item.SubItems[1]);
      colorShapeTo.Brush.Color:=StringToColor(item.SubItems[2]);
    end;
  end;
end;

procedure TvariableForm.FormResize(Sender: TObject);
begin
  ListView1.Width:=ClientWidth-ListView1.Left-5;
  ListView1.height:=valueEdt.top-5-listview1.top;
end;

procedure TvariableForm.colorShapeFromMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ColorDialog1.Execute then
    (sender as tshape).Brush.Color:=ColorDialog1.Color;
end;


const LVIR_BOUNDS=0;
      LVM_FIRST= $1000;
      LVM_GETSUBITEMRECT = LVM_FIRST + 56;
procedure TvariableForm.ListView1CustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
var rec:trect;
    start,dest: tcolor;
    Sr,Sg,Sb:longint;
    Dr,Dg,Db:longint;
    r,g,b:longint;

    i:integer;
begin
  if SubItem=2 then begin
    DefaultDraw:=false;
    if Item.SubItems[1]<>'' then begin
//      ListView1.Canvas.brush.Color:=StringToColor(Item.SubItems[3]);
      rec.top:=2;
      rec.left:=LVIR_BOUNDS;
      SendMessage(ListView1.Handle,LVM_GETSUBITEMRECT,item.index,lparam(@rec));
      start:=StringToColor(Item.SubItems[1]);
      dest:=StringToColor(Item.SubItems[2]);
      if start<>dest then begin
        Sr:=GetRValue(start);Sg:=GetgValue(start);Sb:=GetbValue(start);
        Dr:=GetRValue(dest); Dg:=GetgValue(dest); Db:=GetbValue(dest);
        for i:=rec.left to rec.Right do
          with ListView1.Canvas do begin
            r:=(dr*(i-rec.left)) div (rec.right-rec.left)+(sr*(rec.Right-i)) div (rec.right-rec.left);
            g:=(dg*(i-rec.left)) div (rec.right-rec.left)+(sg*(rec.Right-i)) div (rec.right-rec.left);
            b:=(db*(i-rec.left)) div (rec.right-rec.left)+(sb*(rec.Right-i)) div (rec.right-rec.left);
            pen.Color:=rgb(r,g,b);
            MoveTo(i,rec.top);
            LineTo(i,rec.bottom);
          end;
      end else ListView1.Canvas.FillRect(rec);
    end;
  end else DefaultDraw:=true;
end;

procedure TvariableForm.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  DefaultDraw:=true;
end;

procedure TvariableForm.ListView1CustomDraw(Sender: TCustomListView;
  const ARect: TRect; var DefaultDraw: Boolean);
begin
  DefaultDraw:=true;
end;

procedure TvariableForm.resetClick(Sender: TObject);
begin
  ListView1SelectItem(ListView1,ListView1.Selected,true);
end;

procedure TvariableForm.ListView1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var item:TListItem;
    rec: TRect;
begin
  if button=mbleft then begin
    item:=ListView1.GetItemAt(x,y);
    if (item=nil) or (item.subitems[1]='') then exit;
    rec.top:=2;
    rec.left:=LVIR_BOUNDS;
    SendMessage(ListView1.Handle,LVM_GETSUBITEMRECT,item.index,lparam(@rec));
    if PtInRect(rec,point(x,y)) then begin
      if 2*x<rec.Left+Rec.Right then begin
        ColorDialog1.Color:=StringToColor(Item.SubItems[1]);
        if ColorDialog1.Execute then begin
          Item.SubItems[1]:=ColorToString(ColorDialog1.Color);
          PVariable(item.Data).renderInfo.minColor:=ColorDialog1.Color;
        end;
      end else begin
        ColorDialog1.Color:=StringToColor(Item.SubItems[2]);
        if ColorDialog1.Execute then begin
          Item.SubItems[2]:=ColorToString(ColorDialog1.Color);
          PVariable(item.Data).renderInfo.maxColor:=ColorDialog1.Color;
        end;
      end;
      if item=ListView1.Selected then reset.Click;
    end;
    ListView1.Refresh;
    renderOutputForm.redraw;
  end;
end;

end.
